#include "TestControl.h"
#include "TestSuitTree.h"

TestControl::TestControl(TestSuitTree *arg_p_tree)
  : app_(WApplication::instance())
{
  this->setStyleClass("testcontrol");
  treeName_ = new WText("No test suit will be started",this);
  new WBreak(this);
  startButton_ = new WPushButton("start",this);
  stopButton_ = new WPushButton("stop",this);
  

  testSuitTree_ = arg_p_tree;
  treeEventConnection_ = 
    testSuitTree_->treeEvent().connect(SLOT(this,
					   TestControl::showTreeName));
  
  app_->enableUpdates();  
}

TestControl::~TestControl()
{
  treeEventConnection_.disconnect();
}

void TestControl::startTest(){
  // startButton_->disable();
  //stopButton_ ->enable();
}

void TestControl::stopTest(){
  //stopButton_ ->disable();
  //startButton_->enable();
}

void TestControl::showTreeName(std::string arg_name){
  WApplication::UpdateLock lock = app_->getUpdateLock();

  std::string display = arg_name + " will be started";
  const char* name = display.c_str();
  treeName_->setText("");
  treeName_->setText(name);
  app_->triggerUpdate();
}
