#include "TestSuitTree.h"
#include <stdio.h>

TestSuitTree::TestSuitTree()
  : map_(new WSignalMapper<std::string,bool>(this))
{
  map_->mapped().connect(SLOT(this,TestSuitTree::folderClickProcess));
  this->setStyleClass("testtreeview");

  //WIconPair *folderIcon = new WIconPair("icons/yellow-folder-closed.png",
  //					"icons/yellow-folder-open.png", false);
 
  WTree *tree = new WTree(this);
  tree->setSelectionMode(SingleSelection);

  WTreeNode *root = createFolder("All Tree Suite");
  root->setStyleClass("example-tree");
  tree->setTreeRoot(root);
  root->label()->setTextFormat(PlainText);
  root->setImagePack("resources/");
  root->setLoadPolicy(Wt::WTreeNode::NextLevelLoading);

  WTreeNode *testsuit = createFolder("Test Suite1");
  testsuit->addChildNode(createFile("Test Case1"));
  testsuit->addChildNode(createFile("Test Case2"));
  testsuit->addChildNode(createFile("Test Case3"));
  testsuit->expand();
  root->addChildNode(testsuit);
  
  testsuit = createFolder("Test Suite2");
  testsuit->addChildNode(createFile("Test Case4"));
  testsuit->addChildNode(createFile("Test Case5"));
  testsuit->expand();
  root->addChildNode(testsuit);

  root->expand();  
}

WTreeNode* TestSuitTree::createFolder(std::string arg_name){
  WIconPair *folderIcon = new WIconPair("icons/yellow-folder-closed.png",
					"icons/yellow-folder-open.png", false);
  WTreeNode *result = new WTreeNode(arg_name,folderIcon);
  map_->mapConnect1(result->selected(),arg_name);
  return result;

}

WTreeNode* TestSuitTree::createFile(std::string arg_name){
   WIconPair *fileIcon = new WIconPair("icons/file.gif","icons/file.gif",false);
   
   WTreeNode *result = new WTreeNode(arg_name,fileIcon);
   map_->mapConnect1(result->selected(),arg_name);
   return result;
}

void TestSuitTree::folderClickProcess(std::string arg_name,bool flag){
  if (flag){
    const char* name = arg_name.c_str();
    printf("%s is clicked, bool is %d\n", name, flag);
    //boost::mutex::scoped_lock lock(mutex_);
    treeEvent_.emit(arg_name);
  }
}
