#include "TestWebUI.h"
#include "TestSuitTree.h"
#include "TestControl.h"
#include "TestLogView.h"

TestWebUI::TestWebUI(const WEnvironment& env)
  : WApplication(env)
{
  setTwoPhaseRenderingThreshold(0);
  setTitle("Test Web UI");
  useStyleSheet("styles.css");
  setCssTheme("polished");

  root()->setStyleClass("maindiv");

  testSuitTree_ = new TestSuitTree();
  testControl_  = new TestControl(testSuitTree_);
  testLogView_  = new TestLogView();
  WGridLayout *layout = new WGridLayout();
 
  layout->addWidget(createTitle("Test Web UI"), 0, 0);
  //layout->addWidget(createTitle("Test Content"), 0, 1);
  layout->addWidget(testSuitTree_, 1, 0 );
  layout->setColumnResizable(0);

  WVBoxLayout *vbox = new WVBoxLayout();
  vbox->addWidget(testControl_,1);
  vbox->addWidget(testLogView_,5);
  vbox->setSpacing(10);
  vbox->setResizable(0);

  layout->addLayout(vbox, 1, 1);
  
  layout->setHorizontalSpacing(10);
  layout->setRowStretch(1, 1);
  layout->setColumnStretch(1, 1);
 
  root()->setLayout(layout);
}

WText *TestWebUI::createTitle(const WString& title){
  WText *result = new WText(title);
  result->setInline(false);
  result->setStyleClass("title");
  return result;
}

WText *TestWebUI::aboutDisplay(){
  WText *result = new WText("about: this is GUI Test");
  result->setStyleClass("about");
  return result;
}
